## mympd 16.0.1

=== CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

# minimal cmake version needed for new option handling
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
cmake_policy(SET CMP0003 NEW)

# myMPD is written in C
# supported compilers: gcc, clang
project(mympd
  VERSION 16.0.1
  LANGUAGES C
)

# output binaries in bin directory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

message("Cmake version: ${CMAKE_VERSION}")
message("Cmake src dir: ${PROJECT_SOURCE_DIR}")
message("Cmake build dir: ${CMAKE_CURRENT_BINARY_DIR}")
message("Cmake build type: ${CMAKE_BUILD_TYPE}")
message("Compiler: ${CMAKE_C_COMPILER_ID} ${CMAKE_C_COMPILER_VERSION}")
message("CMAKE_C_FLAGS: ${CMAKE_C_FLAGS}")
message("CMAKE_EXE_LINKER_FLAGS: ${CMAKE_EXE_LINKER_FLAGS}")
message("Arch: ${CMAKE_C_LIBRARY_ARCHITECTURE}")

# reset cmake default flags
set(CMAKE_C_FLAGS_DEBUG "")
set(CMAKE_C_FLAGS_RELEASE "")
set(CMAKE_C_FLAGS_RELWITHDEBINFO "")
set(CMAKE_C_FLAGS_MINSIZEREL "")

# default is to deliver the assets from htdocs for Debug
# and embedded assets for all other build types
if(NOT DEFINED MYMPD_EMBEDDED_ASSETS)
  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(MYMPD_EMBEDDED_ASSETS "OFF")
  else()
    set(MYMPD_EMBEDDED_ASSETS "ON")
  endif()
endif()

# available options
option(MYMPD_BUILD_TESTING "Enables building of unit tests" "OFF")
option(MYMPD_DOC "Installs documentation, default ON" "ON")
option(MYMPD_DOC_HTML "Creates and installs the html documentation, default OFF" "OFF")
option(MYMPD_EMBEDDED_ASSETS "Embed assets in binary, default ON, OFF for Debug" "ON")
option(MYMPD_ENABLE_EXPERIMENTAL "Enable experimental features" "OFF")
option(MYMPD_ENABLE_FLAC "Enables flac support, default ON" "ON")
option(MYMPD_ENABLE_IPV6 "Enables IPv6, default ON" "ON")
option(MYMPD_ENABLE_LIBID3TAG "Enables libid3tag support, default ON" "ON")
option(MYMPD_ENABLE_LUA "Enables lua support, default ON" "ON")
option(MYMPD_ENABLE_MYGPIOD "Enables myGPIOd support, default ON" "ON")
option(MYMPD_MANPAGES "Creates and installs manpages" "ON")
option(MYMPD_MINIMAL "Enables minimal myMPD build, disables all MYMPD_ENABLE_* flags" "OFF")
option(MYMPD_STARTUP_SCRIPT "Installs the startup script, default ON" "ON")
# sanitizer options
option(MYMPD_ENABLE_ASAN "Enables build with address sanitizer, default OFF" "OFF")
option(MYMPD_ENABLE_TSAN "Enables build with thread sanitizer, default OFF" "OFF")
option(MYMPD_ENABLE_UBSAN "Enables build with undefined behavior sanitizer, default OFF" "OFF")

if(MYMPD_MINIMAL)
  set(MYMPD_ENABLE_FLAC "OFF")
  set(MYMPD_ENABLE_IPV6 "OFF")
  set(MYMPD_ENABLE_LUA "OFF")
  set(MYMPD_ENABLE_LIBID3TAG "OFF")
  set(MYMPD_ENABLE_MYGPIOD "OFF")
endif()

if(MYMPD_ENABLE_EXPERIMENTAL)
  message("Experimental features enabled")
endif()

# cmake modules
include(CheckCCompilerFlag)
include(CheckCSourceCompiles)
include(CheckIPOSupported)
include(GNUInstallDirs)

# custom cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake/")

# required dependencies
find_package(Threads REQUIRED)
find_package(PCRE2 REQUIRED)
find_library(MATH_LIB m REQUIRED)
find_package(OpenSSL REQUIRED)

# check dependencies versions
if(OPENSSL_VERSION VERSION_LESS "1.1.0")
  message(FATAL_ERROR "myMPD requires an OpenSSL version greater or equal 1.1.0")
endif()

# optional dependencies
if(MYMPD_ENABLE_LIBID3TAG)
  message("Searching for libid3tag")
  find_package(LIBID3TAG)
  if(NOT LIBID3TAG_FOUND)
    message("Libid3tag is disabled because it was not found")
    set(MYMPD_ENABLE_LIBID3TAG "OFF")
  endif()
else()
  message("Libid3tag is disabled by user")
endif()

if(MYMPD_ENABLE_FLAC)
  message("Searching for flac")
  find_package(FLAC)
  if(NOT FLAC_FOUND)
    message("Flac is disabled because it was not found")
    set(MYMPD_ENABLE_FLAC "OFF")
  endif()
else()
  message("Flac is disabled by user")
endif()

if(MYMPD_ENABLE_LUA)
  if(EXISTS "/etc/alpine-release")
    set(ENV{LUA_DIR} "/usr/lib/lua5.4")
  endif()
  message("Searching for lua")
  find_package(Lua)
  if(LUA_FOUND)
    if(NOT LUA_VERSION_STRING VERSION_GREATER_EQUAL "5.3.0")
      message("Lua is disabled because a version lower than 5.3.0 was found")
      set(MYMPD_ENABLE_LUA "OFF")
      set(MYMPD_ENABLE_MYGPIOD "OFF")
    endif()
  else()
    message("Lua is disabled because it was not found")
    set(MYMPD_ENABLE_LUA "OFF")
    set(MYMPD_ENABLE_MYGPIOD "OFF")
  endif()
else()
  message("Lua is disabled by user")
  set(MYMPD_ENABLE_MYGPIOD "OFF")
endif()

if(MYMPD_ENABLE_MYGPIOD)
  message("Searching for libmygpio")
  find_package(LIBMYGPIO)
  if(NOT LIBMYGPIO_FOUND)
    message("Compiling static version of libmygpio")
    set(MYMPD_ENABLE_MYGPIOD_STATIC "ON")
  endif()
else()
  message("myGPIO support is disabled by user")
endif()

# calculate paths
if(CMAKE_INSTALL_PREFIX MATCHES "/usr")
  set(SUBDIR "/${PROJECT_NAME}")
  set(SUBDIRLIB "/lib")
  set(SUBDIRCACHE "/cache")
else()
  # for install in /opt
  set(SUBDIR "")
  set(SUBDIRLIB "")
  set(SUBDIRCACHE "")
endif()

message("Executables in: ${CMAKE_INSTALL_FULL_BINDIR}")

if(CMAKE_INSTALL_PREFIX STREQUAL "/usr/local")
  set(MYMPD_WORK_DIR "/${CMAKE_INSTALL_LOCALSTATEDIR}${SUBDIRLIB}${SUBDIR}")
  set(MYMPD_CACHE_DIR "/${CMAKE_INSTALL_LOCALSTATEDIR}${SUBDIRCACHE}${SUBDIR}")
else()
  set(MYMPD_WORK_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}${SUBDIRLIB}${SUBDIR}")
  set(MYMPD_CACHE_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}${SUBDIRCACHE}${SUBDIR}")
endif()

message("Workdir: ${MYMPD_WORK_DIR}")
message("Cachedir: ${MYMPD_CACHE_DIR}")

# create assets and set doc root
set(ENV{MYMPD_BUILDDIR} "${CMAKE_CURRENT_BINARY_DIR}")
set(ENV{MYMPD_ENABLE_MYGPIOD} "${MYMPD_ENABLE_MYGPIOD}")
set(ENV{MYMPD_ENABLE_LUA} "${MYMPD_ENABLE_LUA}")

if(MYMPD_EMBEDDED_ASSETS)
  message("Embedding assets in binary")
  set(MYMPD_DOC_ROOT "${MYMPD_WORK_DIR}/empty")
  set(MYMPD_LUALIBS_PATH "")
  execute_process(COMMAND "${PROJECT_SOURCE_DIR}/build.sh" createassets RESULT_VARIABLE RC_CREATE_ASSETS)
  # remove object files with embedded assets
  file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/src/CMakeFiles/mympd.dir/web_server/utility.c.o")
  file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/src/CMakeFiles/mympd.dir/mympd_api/scripts.c.o")
else()
  message("Serving assets from filesystem")
  set(MYMPD_DOC_ROOT "${PROJECT_SOURCE_DIR}/htdocs")
  set(MYMPD_LUALIBS_PATH "${CMAKE_CURRENT_BINARY_DIR}/contrib/lualibs")
  execute_process(COMMAND "${PROJECT_SOURCE_DIR}/build.sh" copyassets RESULT_VARIABLE RC_CREATE_ASSETS)
endif()

if(RC_CREATE_ASSETS GREATER 0)
  message(FATAL_ERROR "Creating assets failed")
endif()

message("Document root: ${MYMPD_DOC_ROOT}")
message("Docdir: ${CMAKE_INSTALL_FULL_DOCDIR}")

# translation files
if(MYMPD_EMBEDDED_ASSETS)
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/bg-BG.json.gz")
    set(I18N_bg_BG "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/de-DE.json.gz")
    set(I18N_de_DE "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/en-US.json.gz")
    set(I18N_en_US "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/es-AR.json.gz")
    set(I18N_es_AR "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/es-ES.json.gz")
    set(I18N_es_ES "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/es-VE.json.gz")
    set(I18N_es_VE "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/fi-FI.json.gz")
    set(I18N_fi_FI "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/fr-FR.json.gz")
    set(I18N_fr_FR "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/it-IT.json.gz")
    set(I18N_it_IT "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/ja-JP.json.gz")
    set(I18N_ja_JP "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/ko-KR.json.gz")
    set(I18N_ko_KR "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/nl-NL.json.gz")
    set(I18N_nl_NL "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/pl-PL.json.gz")
    set(I18N_pl_PL "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/ru-RU.json.gz")
    set(I18N_ru_RU "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/zh-Hans.json.gz")
    set(I18N_zh_Hans "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/zh-Hant.json.gz")
    set(I18N_zh_Hant "ON")
  endif()
endif()

# create html documentation
if(MYMPD_DOC_HTML)
  execute_process(COMMAND "${PROJECT_SOURCE_DIR}/build.sh" doc "${PROJECT_BINARY_DIR}/htmldoc" RESULT_VARIABLE RC_CREATE_DOC)
endif()
if(RC_CREATE_DOC GREATER 0)
  message(FATAL_ERROR "Creating documentation failed")
endif()

# configure some files - version and path information
configure_file(src/compile_time.h.in "${PROJECT_BINARY_DIR}/compile_time.h")
configure_file(cmake/Install.cmake.in cmake/Install.cmake @ONLY)
configure_file(contrib/initscripts/mympd.service.system.in contrib/initscripts/system/mympd.service @ONLY)
configure_file(contrib/initscripts/mympd.service.user.in contrib/initscripts/user/mympd.service @ONLY)
configure_file(contrib/initscripts/mympd.sysVinit.in contrib/initscripts/mympd.sysVinit @ONLY)
configure_file(contrib/initscripts/mympd.openrc.in contrib/initscripts/mympd.openrc @ONLY)
configure_file(contrib/initscripts/mympd.freebsdrc.in contrib/initscripts/mympd.freebsdrc @ONLY)

# global compile options
add_compile_options(
  "-DMPACK_HAS_CONFIG=1"
)
# set myMPD specific debug define
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_compile_options(
    "-DMYMPD_DEBUG=ON"
  )
endif()

if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
  # set strict global compile flags
  add_compile_options(
    "-fdata-sections"
    "-ffunction-sections"
    "-fstack-protector-strong"
    "-pedantic"
    "-Wall"
    "-Werror"
    "-Wextra"
    "-Wformat"
    "-Wformat-security"
    "-Winit-self"
    "-Wmissing-include-dirs"
    "-Wnested-externs"
    "-Wold-style-definition"
    "-Wredundant-decls"
    "-Wshadow"
    "-Wsign-compare"
    "-Wstrict-prototypes"
    "-Wundef"
    "-Wuninitialized"
    "-Wunused-parameter"
    "-Wvla"
    "-Wwrite-strings"
  )

  # check for supported compiler flags
  foreach(FLAG IN ITEMS "-std=gnu17" "-fstack-clash-protection" "-fcf-protection" "-fno-plt")
    message("Checking for compiler flag ${FLAG}")
    unset(COMPILER_SUPPORTS_FLAG CACHE)
    unset(COMPILER_SUPPORTS_FLAG)
    check_c_compiler_flag("${FLAG}" COMPILER_SUPPORTS_FLAG)
    if(COMPILER_SUPPORTS_FLAG)
      add_compile_options("${FLAG}")
    endif()
  endforeach()

  if(NOT MYMPD_ENABLE_ASAN AND NOT MYMPD_ENABLE_UBSAN)
    # incompatible with address sanitizers
    if(NOT CMAKE_C_FLAGS MATCHES "_FORTIFY_SOURCE")
      add_compile_options("-D_FORTIFY_SOURCE=2")
    endif()
  endif()
else()
  # if CMAKE_BUILD_TYPE is neither Release nor Debug,
  # do not alter compile options
endif()

# sanitizers
set(ASAN_FLAGS
  "-fsanitize=address"
  "-fsanitize=leak"
)

set(UBSAN_FLAGS
  "-fsanitize=undefined"
)

set(TSAN_FLAGS
  "-fsanitize=thread"
)

if(MYMPD_ENABLE_ASAN)
  message("Compiling with address sanitizer")
  add_compile_options(
    ${ASAN_FLAGS}
    "-fno-omit-frame-pointer"
  )
elseif(MYMPD_ENABLE_UBSAN)
  message("Compiling with undefined behavior sanitizer")
  add_compile_options(
    ${UBSAN_FLAGS}
    "-fno-omit-frame-pointer"
  )
elseif(MYMPD_ENABLE_TSAN)
  message("Compiling with thread sanitizer")
  add_compile_options(
    ${TSAN_FLAGS}
    "-fno-omit-frame-pointer"
  )
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_compile_options(
    "-ggdb"
    "-Og"
  )
  set(CMAKE_INTERPROCEDURAL_OPTIMIZATION FALSE)
elseif(CMAKE_BUILD_TYPE MATCHES "(Release|RelWithDebInfo|MinSizeRel)")
  add_compile_options(
    "-fPIE"
    "-O2"
  )
  if(CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
    message("Generating binary with debug symbols")

=== cli_tools/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

if(LUA_FOUND)
  add_subdirectory("mympd-script")
endif()

=== dist/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_subdirectory(libmympdclient)
add_subdirectory(mjson)
add_subdirectory(mpack)
add_subdirectory(mongoose)
add_subdirectory(rax)
add_subdirectory(sds)

if(MYMPD_ENABLE_MYGPIOD_STATIC)
    add_subdirectory(myGPIOd)
endif()

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_executable(mympd "")

if(CMAKE_BUILD_TYPE MATCHES "(Release|Debug)")
  target_compile_options(mympd
    PRIVATE
      "-Wconversion"
      "-Wformat=2"
  )
endif()

target_include_directories(mympd
  PRIVATE 
    ${PROJECT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR}
    ${OPENSSL_INCLUDE_DIR}
)

target_include_directories(mympd SYSTEM PRIVATE ${PCRE2_INCLUDE_DIRS})

if(MYMPD_ENABLE_LIBID3TAG)
  target_include_directories(mympd SYSTEM PRIVATE ${LIBID3TAG_INCLUDE_DIRS})
endif()
if(MYMPD_ENABLE_FLAC)
  target_include_directories(mympd SYSTEM PRIVATE ${FLAC_INCLUDE_DIRS})
endif()
if(MYMPD_ENABLE_LUA)
  target_include_directories(mympd SYSTEM PRIVATE ${LUA_INCLUDE_DIR})
endif()
if(MYMPD_ENABLE_MYGPIOD)
  if(MYMPD_ENABLE_MYGPIOD_STATIC)
    target_include_directories(mympd SYSTEM PRIVATE "${PROJECT_SOURCE_DIR}/dist/myGPIOd/libmygpio/include")
  else()
    target_include_directories(mympd SYSTEM PRIVATE ${LIBMYGPIO_INCLUDE_DIRS})
  endif()
endif()

target_sources(mympd
  PRIVATE
    main.c
    lib/api.c
    lib/cache_disk_images.c
    lib/cache_disk_lyrics.c
    lib/cache_disk.c
    lib/cache_rax_album.c
    lib/cache_rax.c
    lib/cert.c
    lib/config.c
    lib/convert.c
    lib/datetime.c
    lib/env.c
    lib/event.c
    lib/fields.c
    lib/filehandler.c
    lib/handle_options.c
    lib/http_client.c
    lib/jsonrpc.c
    lib/last_played.c
    lib/list.c
    lib/log.c
    lib/m3u.c
    lib/mg_str_utils.c
    lib/mimetype.c
    lib/mpack.c
    lib/passwd.c
    lib/pin.c
    lib/msg_queue.c
    lib/mympd_state.c
    lib/random.c
    lib/rax_extras.c
    lib/sds_extras.c
    lib/smartpls.c
    lib/sticker.c
    lib/state_files.c
    lib/thread.c
    lib/timer.c
    lib/utility.c
    lib/validate.c
    mpd_client/autoconf.c
    mpd_client/connection.c
    mpd_client/errorhandler.c
    mpd_client/features.c
    mpd_client/idle.c
    mpd_client/jukebox.c
    mpd_client/partitions.c
    mpd_client/playlists.c
    mpd_client/queue.c
    mpd_client/presets.c
    mpd_client/random_select.c
    mpd_client/search.c
    mpd_client/search_local.c
    mpd_client/stickerdb.c
    mpd_client/shortcuts.c
    mpd_client/tags.c
    mpd_client/volume.c
    mpd_worker/mpd_worker.c
    mpd_worker/add_random.c
    mpd_worker/album_cache.c
    mpd_worker/api.c
    mpd_worker/jukebox.c
    mpd_worker/playlists.c
    mpd_worker/smartpls.c
    mpd_worker/state.c
    mpd_worker/song.c
    mympd_api/mympd_api.c
    mympd_api/albumart.c
    mympd_api/browse.c
    mympd_api/channel.c
    mympd_api/database.c
    mympd_api/extra_media.c
    mympd_api/filesystem.c
    mympd_api/home.c
    mympd_api/jukebox.c
    mympd_api/last_played.c
    mympd_api/lyrics.c
    mympd_api/mounts.c
    mympd_api/mympd_api_handler.c
    mympd_api/outputs.c
    mympd_api/partitions.c
    mympd_api/pictures.c
    mympd_api/playlists.c
    mympd_api/queue.c
    mympd_api/requests.c
    mympd_api/search.c
    mympd_api/settings.c
    mympd_api/smartpls.c
    mympd_api/song.c
    mympd_api/stats.c
    mympd_api/status.c
    mympd_api/sticker.c
    mympd_api/tagart.c
    mympd_api/timer.c
    mympd_api/timer_handlers.c
    mympd_api/trigger.c
    mympd_api/volume.c
    mympd_api/webradios.c
    web_server/web_server.c
    web_server/albumart.c
    web_server/folderart.c
    web_server/request_handler.c
    web_server/proxy.c
    web_server/radiobrowser.c
    web_server/sessions.c
    web_server/playlistart.c
    web_server/tagart.c
    web_server/utility.c
    web_server/webradiodb.c
)

if(MYMPD_ENABLE_LUA)
  target_sources(mympd
    PRIVATE
      mympd_api/lua_mympd_state.c
      scripts/api_handler.c
      scripts/api_scripts.c
      scripts/api_vars.c
      scripts/events.c
      scripts/interface_caches.c
      scripts/interface_http.c
      scripts/interface_mympd_api.c
      scripts/interface_util.c
      scripts/interface.c
      scripts/scripts_lua.c
      scripts/scripts_worker.c
      scripts/scripts.c
      scripts/util.c
      web_server/scripts.c
  )
endif()

if(MYMPD_ENABLE_FLAC)
  target_sources(mympd
    PRIVATE
      mympd_api/lyrics_flac.c
      web_server/albumart_flac.c
  )
endif()

if(MYMPD_ENABLE_LIBID3TAG)
  target_sources(mympd
    PRIVATE
      mympd_api/lyrics_id3.c
      web_server/albumart_id3.c
  )
endif()

if(MYMPD_ENABLE_MYGPIOD)
  target_sources(mympd
    PRIVATE
      scripts/interface_mygpio.c
  )
endif()

=== test/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

set(MYMPD_BUILD_DIR "${PROJECT_BINARY_DIR}")
configure_file(utility.h.in "${PROJECT_BINARY_DIR}/test/utility.h")

set(TEST_SOURCES
  main.c
  utility.c
    ../src/lib/api.c
  ../src/lib/cache_disk_lyrics.c
  ../src/lib/cache_rax_album.c
  ../src/lib/cache_rax.c
  ../src/lib/cert.c
  ../src/lib/config.c
  ../src/lib/convert.c
  ../src/lib/datetime.c
  ../src/lib/event.c
  ../src/lib/env.c
  ../src/lib/fields.c
  ../src/lib/filehandler.c
  ../src/lib/http_client.c
  ../src/lib/jsonrpc.c
  ../src/lib/last_played.c
  ../src/lib/list.c
  ../src/lib/log.c
  ../src/lib/m3u.c
  ../src/lib/mg_str_utils.c
  ../src/lib/mimetype.c
  ../src/lib/mpack.c
  ../src/lib/msg_queue.c
  ../src/lib/mympd_state.c
  ../src/lib/passwd.c
  ../src/lib/random.c
  ../src/lib/rax_extras.c
  ../src/lib/sds_extras.c
  ../src/lib/state_files.c
  ../src/lib/sticker.c
  ../src/lib/timer.c
  ../src/lib/utility.c
  ../src/lib/validate.c
  ../src/mpd_client/connection.c
  ../src/mpd_client/errorhandler.c
  ../src/mpd_client/features.c
  ../src/mpd_client/jukebox.c
  ../src/mpd_client/presets.c
  ../src/mpd_client/queue.c
  ../src/mpd_client/random_select.c
  ../src/mpd_client/search.c
  ../src/mpd_client/search_local.c
  ../src/mpd_client/shortcuts.c
  ../src/mpd_client/stickerdb.c
  ../src/mpd_client/tags.c
  ../src/mpd_client/jukebox.c
  ../src/mpd_client/volume.c
  ../src/mympd_api/extra_media.c
  ../src/mympd_api/home.c
  ../src/mympd_api/last_played.c
  ../src/mympd_api/jukebox.c
  ../src/mympd_api/lua_mympd_state.c
  ../src/mympd_api/lyrics.c
  ../src/mympd_api/requests.c
  ../src/mympd_api/settings.c
  ../src/mympd_api/status.c
  ../src/mympd_api/sticker.c
  ../src/mympd_api/timer.c
  ../src/mympd_api/timer_handlers.c
  ../src/mympd_api/trigger.c
  ../src/mympd_api/queue.c
  ../src/mympd_api/webradios.c
  ../src/scripts/events.c
  tests/test_album_cache.c
  tests/test_api.c
  tests/test_cert.c
  tests/test_convert.c
  tests/test_datetime.c
  tests/test_env.c
  tests/test_filehandler.c
  tests/test_http_client.c
  tests/test_jsonrpc.c
  tests/test_list.c
  tests/test_m3u.c
  tests/test_mimetype.c
  tests/test_mympd_queue.c
  tests/test_mympd_state.c
  tests/test_radix_sort.c
  tests/test_random.c
  tests/test_sds_extras.c
  tests/test_search_local.c
  tests/test_state_files.c
  tests/test_tags.c
  tests/test_timer.c
  tests/test_utility.c
  tests/test_validate.c
)

if(LIBID3TAG_FOUND)
  set(TEST_SOURCES_LIBID3TAG
    ../src/mympd_api/lyrics_id3.c
    tests/test_lyrics_id3.c
  )
endif()
if(FLAC_FOUND)
  set(TEST_SOURCES_FLAC
  ../src/mympd_api/lyrics_flac.c
    tests/test_lyrics_flac.c
  )
endif()

add_executable(unit_test
  ${TEST_SOURCES}
  ${TEST_SOURCES_LIBID3TAG}
  ${TEST_SOURCES_FLAC}
)

target_include_directories(unit_test
  PRIVATE 
    ${PROJECT_BINARY_DIR}
    ${PROJECT_BINARY_DIR}/test
    ${PROJECT_SOURCE_DIR}
)

target_compile_options(unit_test
  PRIVATE
    "-Wno-unused-function"
    "-Wno-redundant-decls"
)

target_link_libraries(unit_test
  mympdclient
  mjson
  mpack
  mongoose
  rax
  sds
  ${CMAKE_THREAD_LIBS_INIT}
  ${MATH_LIB}
  ${OPENSSL_LIBRARIES}
  ${PCRE2_LIBRARIES}
)

# link optional dependencies
if(LIBID3TAG_FOUND)
  target_link_libraries(unit_test ${LIBID3TAG_LIBRARIES})
endif()
if(FLAC_FOUND)
  target_link_libraries(unit_test ${FLAC_LIBRARIES})
endif()

add_custom_command(TARGET unit_test PRE_BUILD
  COMMAND ${CMAKE_COMMAND} -E create_symlink
  ${CMAKE_SOURCE_DIR}/test/testfiles ${PROJECT_BINARY_DIR}/testfiles)

# define tests
list(APPEND test_categories
  "album_cache"
  "api"
  "cert"
  "convert"
  "datetime"
  "env"
  "filehandler"
  "http_client"
  "jsonrpc"
  "list"
  "m3u"
  "mimetype"
  "mympd_queue"
  "mympd_state"
  "passwd"
  "radix_sort"
  "random"
  "sds_extras"
  "search_local"
  "state_files"
  "tags"
  "timer"
  "utility"
  "validate"
)

if(LIBID3TAG_FOUND)
  list(APPEND test_categories "lyrics_id3")
endif()
if(FLAC_FOUND)
  list(APPEND test_categories "lyrics_flac")
endif()

foreach(CAT IN LISTS test_categories)
  add_test(NAME "test_${CAT}" COMMAND "unit_test" "--filter=${CAT}.*")
endforeach()

=== cli_tools/mympd-script/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_executable(mympd-script "")

target_include_directories(mympd-script
  PRIVATE
    ${PROJECT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR}
)

target_sources(mympd-script
  PRIVATE
    mympd-script.c
    ../log.c
    ../../src/lib/convert.c
    ../../src/lib/filehandler.c
    ../../src/lib/http_client.c
    ../../src/lib/list.c
    ../../src/lib/mg_str_utils.c
    ../../src/lib/sds_extras.c
    ../../src/lib/passwd.c
    ../../src/lib/random.c
)

target_link_libraries(mympd-script
  sds
  mongoose
  ${OPENSSL_LIBRARIES}
)

install(TARGETS mympd-script DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})

=== dist/libmympdclient/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(mympdclient "")

target_include_directories(mympdclient PUBLIC include)

target_sources(mympdclient
  PRIVATE
    src/albumart.c
    src/async.c
    src/audio_format.c
    src/binary.c
    src/capabilities.c
    src/cmessage.c
    src/cmount.c
    src/cneighbor.c
    src/connection.c
    src/coutput.c
    src/cpartition.c
    src/cplaylist.c
    src/cstats.c
    src/cstatus.c
    src/database.c
    src/directory.c
    src/entity.c
    src/error.c
    src/fd_util.c
    src/fingerprint.c
    src/idle.c
    src/ierror.c
    src/iso8601.c
    src/kvlist.c
    src/list.c
    src/message.c
    src/mixer.c
    src/mount.c
    src/neighbor.c
    src/output.c
    src/parser.c
    src/partition.c
    src/password.c
    src/player.c
    src/playlist.c
    src/position.c
    src/queue.c
    src/quote.c
    src/replay_gain.c
    src/rdirectory.c
    src/readpicture.c
    src/recv.c
    src/replay_gain.c
    src/resolver.c
    src/response.c
    src/rplaylist.c
    src/run.c
    src/isearch.c
    src/search.c
    src/send.c
    src/settings.c
    src/socket.c
    src/song.c
    src/stats.c
    src/status.c
    src/sticker.c
    src/sync.c
    src/tag.c
)

=== dist/mjson/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(mjson "")

target_sources(mjson
  PRIVATE
    mjson.c
  PUBLIC
    mjson.h
)

target_compile_options(mjson
  PRIVATE
    "-DMJSON_ENABLE_PRINT=0"
    "-DMJSON_ENABLE_BASE64=0"
    "-DMJSON_ENABLE_RPC=0"
    "-DMJSON_ENABLE_PRETTY=0"
    "-DMJSON_ENABLE_MERGE=0"
)

if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
  if((CMAKE_C_COMPILER_ID STREQUAL "Clang") AND (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL "15.0.0"))
    #clang 15 compatibility
    target_compile_options(mjson
      PUBLIC
      "-Wno-unused-but-set-variable"
    )
    message("Enabling workaround for mjson and clang 15")
  endif()
endif()

=== dist/mongoose/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(mongoose "")

target_sources(mongoose
  PRIVATE
    mongoose.c
  PUBLIC
    mongoose.h
)

target_compile_options(mongoose
  PRIVATE
    "-DMG_ENABLE_DIRLIST=1"
    "-DMG_ENABLE_SSI=0"
    "-DMG_TLS=MG_TLS_OPENSSL"
)

if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
  target_compile_options(mongoose
    PRIVATE
      "-Wno-unused-parameter"
  )
endif()

if(MYMPD_ENABLE_IPV6)
  message("Mongoose: IPv6 is enabled")
  target_compile_options(mongoose
    PUBLIC
      "-DMG_ENABLE_IPV6=1"
      "-DMG_IPV6_V6ONLY=0"
  )
else()
  message("Mongoose: IPv6 is disabled")
endif()

target_include_directories(mongoose SYSTEM
  PRIVATE
    ${OPENSSL_INCLUDE_DIR}
)

=== dist/mpack/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(mpack "")

target_sources(mpack
  PRIVATE
    mpack.c
    mpack-config.h
  PUBLIC
    mpack.h
)

target_include_directories(mpack
  PRIVATE
    ${PROJECT_SOURCE_DIR}
    ${PROJECT_BINARY_DIR}
)

=== dist/myGPIOd/CMakeLists.txt ===
#
# SPDX-License-Identifier: GPL-3.0-or-later
# myGPIOd (c) 2020-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/myGPIOd
#

add_library(mygpio "")

configure_file(mygpio-common/compile_time.h.in "${PROJECT_BINARY_DIR}/dist/myGPIOd/compile_time.h")

target_include_directories(mygpio PRIVATE
  "${PROJECT_SOURCE_DIR}/dist/myGPIOd"
  "${PROJECT_BINARY_DIR}/dist/myGPIOd"
)

target_sources(mygpio
  PRIVATE
    libmygpio/src/buffer.c
    libmygpio/src/connection.c
    libmygpio/src/gpio_struct.c
    libmygpio/src/gpio.c
    libmygpio/src/gpioinfo.c
    libmygpio/src/gpiolist.c
    libmygpio/src/idle.c
    libmygpio/src/parser.c
    libmygpio/src/pair.c
    libmygpio/src/protocol.c
    libmygpio/src/socket.c
    libmygpio/src/util.c
    mygpio-common/util.c
)

=== dist/rax/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(rax "")

target_sources(rax
  PRIVATE
    rax.c
    rax_malloc.h
  PUBLIC
    rax.h
)

target_include_directories(rax
  PRIVATE
    ${PROJECT_SOURCE_DIR}
)

if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
  target_compile_options(rax
    PRIVATE
      "-Wno-shadow"
      "-Wno-incompatible-pointer-types-discards-qualifiers"
  )

  if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    target_compile_options(rax
      PRIVATE
        "-Wno-discarded-qualifiers"
        "-Wno-use-after-free"
    )
  endif()
endif()

=== debian/changelog ===
mympd (16.0.1-1~mx23+1) mx; urgency=medium

  * New upstream release
  * Build for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Fri, 12 Jul 2024 03:26:43 +0000

=== debian/control ===
Source: mympd
Section: sound
Priority: optional
Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
XSBC-Original-Maintainer: Juergen Mang <mail@jcgames.de>
Build-Depends: cmake,
               debhelper-compat (= 13),
               gzip,
               jq,
               libflac-dev,
               libid3tag0-dev,
               liblua5.4-dev,
               lua5.4,
               libpcre2-dev,
               libssl-dev,
               perl
Standards-Version: 4.1.2
Homepage: https://jcorporation.github.io/myMPD/

Package: mympd
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: standalone, mobile friendly web-based MPD client.
 myMPD is a standalone and lightweight web-based MPD client. It's 
 tuned for minimal resource usage and requires very few dependencies.
 Therefore myMPD is ideal for Raspberry Pis and similar devices.

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	dh_auto_configure --  -DCMAKE_BUILD_TYPE=Release

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

%:
	dh $@

## mympd 22.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # SPDX-License-Identifier: GPL-3.0-or-later
-# myMPD (c) 2018-2024 Juergen Mang <mail@jcgames.de>
+# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
 # https://github.com/jcorporation/mympd
 
 # minimal cmake version needed for new option handling
@@ -9,9 +9,14 @@
 # myMPD is written in C
 # supported compilers: gcc, clang
 project(mympd
-  VERSION 16.0.1
+  VERSION 22.1.1
   LANGUAGES C
 )
+
+# Dependency versions
+set(LIBMPDCLIENT_MIN_VERSION "2.24.0")
+set(OPENSSL_MIN_VERSION "1.1.0")
+set(LUA_MIN_VERSION "5.3.0")
 
 # output binaries in bin directory
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
@@ -20,6 +25,7 @@
 message("Cmake src dir: ${PROJECT_SOURCE_DIR}")
 message("Cmake build dir: ${CMAKE_CURRENT_BINARY_DIR}")
 message("Cmake build type: ${CMAKE_BUILD_TYPE}")
+message("Cmake generator: ${CMAKE_GENERATOR}")
 message("Compiler: ${CMAKE_C_COMPILER_ID} ${CMAKE_C_COMPILER_VERSION}")
 message("CMAKE_C_FLAGS: ${CMAKE_C_FLAGS}")
 message("CMAKE_EXE_LINKER_FLAGS: ${CMAKE_EXE_LINKER_FLAGS}")
@@ -42,18 +48,19 @@
 endif()
 
 # available options
-option(MYMPD_BUILD_TESTING "Enables building of unit tests" "OFF")
+option(MYMPD_BUILD_TESTING "Enables building of unit tests, default OFF" "OFF")
 option(MYMPD_DOC "Installs documentation, default ON" "ON")
 option(MYMPD_DOC_HTML "Creates and installs the html documentation, default OFF" "OFF")
 option(MYMPD_EMBEDDED_ASSETS "Embed assets in binary, default ON, OFF for Debug" "ON")
-option(MYMPD_ENABLE_EXPERIMENTAL "Enable experimental features" "OFF")
+option(MYMPD_EMBEDDED_LIBMPDCLIENT "Use embedded libmpdclient, default OFF" "OFF")
+option(MYMPD_ENABLE_EXPERIMENTAL "Enable experimental features, default OFF" "OFF")
 option(MYMPD_ENABLE_FLAC "Enables flac support, default ON" "ON")
 option(MYMPD_ENABLE_IPV6 "Enables IPv6, default ON" "ON")
 option(MYMPD_ENABLE_LIBID3TAG "Enables libid3tag support, default ON" "ON")
 option(MYMPD_ENABLE_LUA "Enables lua support, default ON" "ON")
 option(MYMPD_ENABLE_MYGPIOD "Enables myGPIOd support, default ON" "ON")
-option(MYMPD_MANPAGES "Creates and installs manpages" "ON")
-option(MYMPD_MINIMAL "Enables minimal myMPD build, disables all MYMPD_ENABLE_* flags" "OFF")
+option(MYMPD_MANPAGES "Creates and installs manpages, default ON" "ON")
+option(MYMPD_MINIMAL "Enables minimal myMPD build, disables all MYMPD_ENABLE_* flags, default OFF" "OFF")
 option(MYMPD_STARTUP_SCRIPT "Installs the startup script, default ON" "ON")
 # sanitizer options
 option(MYMPD_ENABLE_ASAN "Enables build with address sanitizer, default OFF" "OFF")
@@ -87,9 +94,35 @@
 find_library(MATH_LIB m REQUIRED)
 find_package(OpenSSL REQUIRED)
 
+if(MYMPD_EMBEDDED_LIBMPDCLIENT STREQUAL "ON")
+  message("Using embedded libmpdclient")
+else()
+  find_package(LIBMPDCLIENT)
+  if(LIBMPDCLIENT_FOUND)
+    if(LIBMPDCLIENT_VERSION VERSION_LESS "${LIBMPDCLIENT_MIN_VERSION}")
+      message(WARNING "libmpdclient ${LIBMPDCLIENT_VERSION} is too old, minimum version is ${LIBMPDCLIENT_MIN_VERSION}")
+      message("Using embedded libmpdclient")
+      set(MYMPD_EMBEDDED_LIBMPDCLIENT "ON")
+    else()
+      message("Using shared libmpdclient ${LIBMPDCLIENT_VERSION}")
+      set(MYMPD_EMBEDDED_LIBMPDCLIENT "OFF")
+    endif()
+  else()
+    message("libmpdclient not found, using embedded libmpdclient")
+    set(MYMPD_EMBEDDED_LIBMPDCLIENT "ON")
+  endif()
+endif()
+
+# set global libmpdclient mode
+if(MYMPD_EMBEDDED_LIBMPDCLIENT)
+  add_compile_options(
+    "-DMYMPD_EMBEDDED_LIBMPDCLIENT=1"
+  )
+endif()
+
 # check dependencies versions
-if(OPENSSL_VERSION VERSION_LESS "1.1.0")
-  message(FATAL_ERROR "myMPD requires an OpenSSL version greater or equal 1.1.0")
+if(OPENSSL_VERSION VERSION_LESS "${OPENSSL_MIN_VERSION}")
+  message(FATAL_ERROR "myMPD requires an OpenSSL version greater or equal ${OPENSSL_MIN_VERSION}")
 endif()
 
 # optional dependencies
@@ -97,7 +130,7 @@
   message("Searching for libid3tag")
   find_package(LIBID3TAG)
   if(NOT LIBID3TAG_FOUND)
-    message("Libid3tag is disabled because it was not found")
+    message(WARNING "Libid3tag is disabled because it was not found")
     set(MYMPD_ENABLE_LIBID3TAG "OFF")
   endif()
 else()
@@ -108,7 +141,7 @@
   message("Searching for flac")
   find_package(FLAC)
   if(NOT FLAC_FOUND)
-    message("Flac is disabled because it was not found")
+    message(WARNING "Flac is disabled because it was not found")
     set(MYMPD_ENABLE_FLAC "OFF")
   endif()
 else()
@@ -122,13 +155,13 @@
   message("Searching for lua")
   find_package(Lua)
   if(LUA_FOUND)
-    if(NOT LUA_VERSION_STRING VERSION_GREATER_EQUAL "5.3.0")
-      message("Lua is disabled because a version lower than 5.3.0 was found")
+    if(NOT LUA_VERSION_STRING VERSION_GREATER_EQUAL "${LUA_MIN_VERSION}")
+      message(WARNING "Lua is disabled because a version lower than ${LUA_MIN_VERSION} was found")
       set(MYMPD_ENABLE_LUA "OFF")
       set(MYMPD_ENABLE_MYGPIOD "OFF")
     endif()
   else()
-    message("Lua is disabled because it was not found")
+    message(WARNING "Lua is disabled because it was not found")
     set(MYMPD_ENABLE_LUA "OFF")
     set(MYMPD_ENABLE_MYGPIOD "OFF")
   endif()
@@ -184,7 +217,7 @@
   set(MYMPD_LUALIBS_PATH "")
   execute_process(COMMAND "${PROJECT_SOURCE_DIR}/build.sh" createassets RESULT_VARIABLE RC_CREATE_ASSETS)
   # remove object files with embedded assets
-  file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/src/CMakeFiles/mympd.dir/web_server/utility.c.o")
+  file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/src/CMakeFiles/mympd.dir/webserver/mg_user_data.c.o")
   file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/src/CMakeFiles/mympd.dir/mympd_api/scripts.c.o")
 else()
   message("Serving assets from filesystem")
@@ -262,6 +295,8 @@
 
 # configure some files - version and path information
 configure_file(src/compile_time.h.in "${PROJECT_BINARY_DIR}/compile_time.h")
+configure_file(src/webserver/embedded_files.c.in "${PROJECT_BINARY_DIR}/embedded_files.c")
+configure_file(src/scripts/lualibs.c.in "${PROJECT_BINARY_DIR}/lualibs.c")
 configure_file(cmake/Install.cmake.in cmake/Install.cmake @ONLY)
 configure_file(contrib/initscripts/mympd.service.system.in contrib/initscripts/system/mympd.service @ONLY)
 configure_file(contrib/initscripts/mympd.service.user.in contrib/initscripts/user/mympd.service @ONLY)
@@ -272,7 +307,9 @@
 # global compile options
 add_compile_options(
   "-DMPACK_HAS_CONFIG=1"
+  "-DMG_MAX_HTTP_HEADERS=50"
 )
+
 # set myMPD specific debug define
 if(CMAKE_BUILD_TYPE STREQUAL "Debug")
   add_compile_options(
@@ -281,17 +318,32 @@
 endif()
 
 if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
-  # set strict global compile flags
-  add_compile_options(
+  set(C_OPTS
+    "-D_GLIBCXX_ASSERTIONS"
+    "-D_LIBCXX_ENABLE_ASSERTIONS"
+    "-fcf-protection=full"
     "-fdata-sections"
     "-ffunction-sections"
+    "-fno-delete-null-pointer-checks"
+    "-fno-omit-frame-pointer"
+    "-fno-plt"
+    "-fno-strict-aliasing"
+    "-fno-strict-overflow"
+    "-fstack-clash-protection"
     "-fstack-protector-strong"
+    "-fstrict-flex-arrays=3"
+    "-ftrivial-auto-var-init=zero"
+    "-mbranch-protection=standard"
+    "-mno-omit-leaf-frame-pointer"
+    "-mshstk"
     "-pedantic"
+    "-std=gnu17"
     "-Wall"
     "-Werror"
     "-Wextra"
-    "-Wformat"
+    "-Wformat=2"
     "-Wformat-security"
+    "-Wformat-nonliteral"
     "-Winit-self"
     "-Wmissing-include-dirs"
     "-Wnested-externs"
@@ -299,80 +351,3 @@
     "-Wredundant-decls"
     "-Wshadow"
     "-Wsign-compare"
-    "-Wstrict-prototypes"
-    "-Wundef"
-    "-Wuninitialized"
-    "-Wunused-parameter"
-    "-Wvla"
-    "-Wwrite-strings"
-  )
-
-  # check for supported compiler flags
-  foreach(FLAG IN ITEMS "-std=gnu17" "-fstack-clash-protection" "-fcf-protection" "-fno-plt")
-    message("Checking for compiler flag ${FLAG}")
-    unset(COMPILER_SUPPORTS_FLAG CACHE)
-    unset(COMPILER_SUPPORTS_FLAG)
-    check_c_compiler_flag("${FLAG}" COMPILER_SUPPORTS_FLAG)
-    if(COMPILER_SUPPORTS_FLAG)
-      add_compile_options("${FLAG}")
-    endif()
-  endforeach()
-
-  if(NOT MYMPD_ENABLE_ASAN AND NOT MYMPD_ENABLE_UBSAN)
-    # incompatible with address sanitizers
-    if(NOT CMAKE_C_FLAGS MATCHES "_FORTIFY_SOURCE")
-      add_compile_options("-D_FORTIFY_SOURCE=2")
-    endif()
-  endif()
-else()
-  # if CMAKE_BUILD_TYPE is neither Release nor Debug,
-  # do not alter compile options
-endif()
-
-# sanitizers
-set(ASAN_FLAGS
-  "-fsanitize=address"
-  "-fsanitize=leak"
-)
-
-set(UBSAN_FLAGS
-  "-fsanitize=undefined"
-)
-
-set(TSAN_FLAGS
-  "-fsanitize=thread"
-)
-
-if(MYMPD_ENABLE_ASAN)
-  message("Compiling with address sanitizer")
-  add_compile_options(
-    ${ASAN_FLAGS}
-    "-fno-omit-frame-pointer"
-  )
-elseif(MYMPD_ENABLE_UBSAN)
-  message("Compiling with undefined behavior sanitizer")
-  add_compile_options(
-    ${UBSAN_FLAGS}
-    "-fno-omit-frame-pointer"
-  )
-elseif(MYMPD_ENABLE_TSAN)
-  message("Compiling with thread sanitizer")
-  add_compile_options(
-    ${TSAN_FLAGS}
-    "-fno-omit-frame-pointer"
-  )
-endif()
-
-if(CMAKE_BUILD_TYPE STREQUAL "Debug")
-  add_compile_options(
-    "-ggdb"
-    "-Og"
-  )
-  set(CMAKE_INTERPROCEDURAL_OPTIMIZATION FALSE)
-elseif(CMAKE_BUILD_TYPE MATCHES "(Release|RelWithDebInfo|MinSizeRel)")
-  add_compile_options(
-    "-fPIE"
-    "-O2"
-  )
-  if(CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
-    message("Generating binary with debug symbols")

=== libmpdclient/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(mpdclient "")

target_include_directories(mpdclient SYSTEM PRIVATE "${PROJECT_SOURCE_DIR}/dist/libmpdclient/include")

if(CMAKE_BUILD_TYPE MATCHES "(Release|RelWithDebInfo|MinSizeRel)")
  target_compile_options(mpdclient
    PRIVATE
      "-DNDEBUG"
  )
endif()

target_sources(mpdclient
  PRIVATE
    src/albumart.c
    src/async.c
    src/audio_format.c
    src/binary.c
    src/capabilities.c
    src/cmessage.c
    src/cmount.c
    src/cneighbor.c
    src/connection.c
    src/coutput.c
    src/cpartition.c
    src/cplaylist.c
    src/cstats.c
    src/cstatus.c
    src/database.c
    src/directory.c
    src/entity.c
    src/error.c
    src/fd_util.c
    src/feature.c
    src/fingerprint.c
    src/idle.c
    src/ierror.c
    src/iso8601.c
    src/kvlist.c
    src/list.c
    src/message.c
    src/mixer.c
    src/mount.c
    src/neighbor.c
    src/output.c
    src/parser.c
    src/partition.c
    src/password.c
    src/player.c
    src/playlist.c
    src/position.c
    src/queue.c
    src/quote.c
    src/replay_gain.c
    src/rdirectory.c
    src/readpicture.c
    src/recv.c
    src/replay_gain.c
    src/resolver.c
    src/response.c
    src/rplaylist.c
    src/run.c
    src/request.c
    src/search.c
    src/send.c
    src/settings.c
    src/socket.c
    src/song.c
    src/stats.c
    src/status.c
    src/sticker.c
    src/sync.c
    src/tag.c
    src/stringnormalization.c
)

=== mongoose/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(mongoose "")

target_sources(mongoose
  PRIVATE
    mongoose.c
  PUBLIC
    mongoose.h
)

target_compile_options(mongoose
  PRIVATE
    "-DMG_ENABLE_DIRLIST=1"
    "-DMG_ENABLE_SSI=0"
    "-DMG_TLS=MG_TLS_OPENSSL"
)

if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
  target_compile_options(mongoose
    PRIVATE
      "-Wno-unused-parameter"
  )
endif()

if(MYMPD_ENABLE_IPV6)
  message("Mongoose: IPv6 is enabled")
  target_compile_options(mongoose
    PUBLIC
      "-DMG_ENABLE_IPV6=1"
      "-DMG_IPV6_V6ONLY=0"
  )
else()
  message("Mongoose: IPv6 is disabled")
endif()

target_include_directories(mongoose SYSTEM
  PRIVATE
    ${OPENSSL_INCLUDE_DIR}
)

=== mpack/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(mpack "")

target_sources(mpack
  PRIVATE
    mpack.c
    mpack-config.h
  PUBLIC
    mpack.h
)

target_include_directories(mpack
  PRIVATE
    ${PROJECT_SOURCE_DIR}
    ${PROJECT_BINARY_DIR}
)

if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
  target_compile_options(mpack
    PRIVATE
      "-Wno-format-nonliteral"
  )
endif()

=== myGPIOd/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/myGPIOd

add_library(mygpio "")

configure_file(mygpio-common/compile_time.h.in "${PROJECT_BINARY_DIR}/dist/myGPIOd/compile_time.h")

target_include_directories(mygpio PRIVATE
  "${PROJECT_SOURCE_DIR}/dist/myGPIOd"
  "${PROJECT_BINARY_DIR}/dist/myGPIOd"
)

target_sources(mygpio
  PRIVATE
    libmygpio/src/buffer.c
    libmygpio/src/connection.c
    libmygpio/src/gpio_struct.c
    libmygpio/src/gpio.c
    libmygpio/src/gpioinfo.c
    libmygpio/src/gpiolist.c
    libmygpio/src/idle.c
    libmygpio/src/parser.c
    libmygpio/src/pair.c
    libmygpio/src/protocol.c
    libmygpio/src/socket.c
    libmygpio/src/util.c
    mygpio-common/util.c
)

if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
  target_compile_options(mygpio
    PRIVATE
      "-Wno-format-nonliteral"
  )
endif()

=== mympd-script/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_executable(mympd-script "")

target_include_directories(mympd-script
  PRIVATE
    ${PROJECT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR}
)

target_sources(mympd-script
  PRIVATE
    mympd-script.c
    ../log.c
    ../../src/lib/cacertstore.c
    ../../src/lib/convert.c
    ../../src/lib/filehandler.c
    ../../src/lib/http_client.c
    ../../src/lib/list.c
    ../../src/lib/sds_extras.c
    ../../src/lib/passwd.c
    ../../src/lib/random.c
)

target_link_libraries(mympd-script
  sds
  mongoose
  ${OPENSSL_LIBRARIES}
)

install(TARGETS mympd-script DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})

=== rax/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(rax "")

target_sources(rax
  PRIVATE
    rax.c
    rax_malloc.h
  PUBLIC
    rax.h
)

target_include_directories(rax
  PRIVATE
    ${PROJECT_SOURCE_DIR}
)

if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
  target_compile_options(rax
    PRIVATE
      "-Wno-shadow"
      "-Wno-incompatible-pointer-types-discards-qualifiers"
      "-Wformat"
      "-Wno-format-nonliteral"
  )

  if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    target_compile_options(rax
      PRIVATE
        "-Wno-discarded-qualifiers"
        "-Wno-use-after-free"
    )
  endif()
endif()

=== sds/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(sds "")

target_sources(sds
  PRIVATE
    sds.c
    sdsalloc.h
  PUBLIC
    sds.h
)

target_include_directories(sds
  PRIVATE
    ${PROJECT_SOURCE_DIR}
)

if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
  target_compile_options(sds
    PRIVATE
      "-Wno-format-nonliteral"
  )
endif()

=== packaging/openwrt/Makefile ===
#
# Copyright (C) 2021-2023 Tomasz Maciej Nowak <tmn505@gmail.com>
#
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

include $(TOPDIR)/rules.mk

PKG_NAME := mympd
PKG_VERSION := 22.1.1
PKG_RELEASE := 1

PKG_SOURCE := $(PKG_NAME)-$(PKG_VERSION).tar.gz
PKG_SOURCE_URL := https://codeload.github.com/jcorporation/myMPD/tar.gz/refs/tags/v$(PKG_VERSION)?
PKG_HASH := skip

PKG_LICENSE := GPL-3.0
PKG_LICENSE_FILE := LICENSE.md

PKG_MAINTAINER := Juergen Mang <mail [at] jcgames [dot] de>

PKG_BUILD_DIR := $(BUILD_DIR)/myMPD-$(PKG_VERSION)
PKG_BUILD_FLAGS := no-mips16
PKG_BUILD_PARALLEL := 1
PKG_ASLR_PIE_REGULAR := 1
PKG_FORTIFY_SOURCE := 0
PKG_USE_NINJA := 0
PKG_CONFIG_DEPENDS := \
    CONFIG_MYMPD_FLAC \
    CONFIG_MYMPD_ID3TAG \
    CONFIG_MYMPD_LUA

CMAKE_BINARY_SUBDIR := release

include $(INCLUDE_DIR)/package.mk
include $(INCLUDE_DIR)/cmake.mk

define Package/mympd
  SECTION := sound
  CATEGORY := Sound
  TITLE := myMPD - web MPD client and more
  URL := https://jcorporation.github.io
  DEPENDS := +libpcre2 +MYMPD_FLAC:libflac +MYMPD_ID3TAG:libid3tag +MYMPD_LUA:liblua5.3 +libopenssl
  USERID := mympd:mympd
endef

define Package/mympd/description
Standalone and mobile friendly web MPD client with a tiny footprint and advanced features.
endef

define Package/mympd/config
    if PACKAGE_mympd

        config MYMPD_FLAC
            bool "Extracting cover images from FLAC files"
            default y

        config MYMPD_ID3TAG
            bool "Extracting cover images from ID3 tags"
            default y

        config MYMPD_LUA
            bool "LUA scripts support"
            default n

    endif
endef

CMAKE_OPTIONS += \
    -DMYMPD_ENABLE_FLAC=$(if $(CONFIG_MYMPD_FLAC),ON,OFF) \
    -DMYMPD_ENABLE_LIBID3TAG=$(if $(CONFIG_MYMPD_ID3TAG),ON,OFF) \
    -DMYMPD_ENABLE_LUA=$(if $(CONFIG_MYMPD_LUA),ON,OFF)

define Package/mympd/install
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/mympd $(1)/usr/bin/
    $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/mympd-config $(1)/usr/bin/
	$(if $(CONFIG_MYMPD_LUA),$(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/mympd-script $(1)/usr/bin/)

	$(INSTALL_DIR) $(1)/etc/config
	$(INSTALL_CONF) ./files/mympd.config $(1)/etc/config/mympd
	$(INSTALL_DIR) $(1)/etc/init.d
	$(INSTALL_BIN) ./files/mympd.init $(1)/etc/init.d/mympd
endef

$(eval $(call BuildPackage,mympd))

=== packaging/freebsd/multimedia/mympd/Makefile ===
PORTNAME=	myMPD
DISTVERSIONPREFIX= v
DISTVERSION=	22.1.1
CATEGORIES=	multimedia

MAINTAINER=	robert.david@posteo.net
COMMENT=	Standalone and mobile friendly web-based MPD client
WWW=		https://github.com/jcorporation/myMPD

LICENSE=	GPLv3+

BUILD_DEPENDS=	jq:textproc/jq
LIB_DEPENDS=	libpcre2-8.so:devel/pcre2 \
		libid3tag.so:audio/libid3tag \
		libFLAC.so:audio/flac \
		libogg.so:audio/libogg \
		liblua-5.4.so:lang/lua54

USES=		cmake:noninja perl5
USE_PERL5=	build
USE_GITHUB=	yes
GH_ACCOUNT=	jcorporation

.include <bsd.port.mk>

=== debian/changelog ===
mympd (22.1.1-1) unstable; urgency=medium

  * Release from master

 -- Juergen Mang <mail@jcgames.de>  Sat, 11 Oct 2025 12:10:13 +0200
